'37_in_1, Rotary Encoder KY-040, Debounce

$regfile = "m328pdef.dat"
$crystal = 16000000
$hwstack = 20
$swstack = 20
$framesize = 80

Dim Cw_cnt As Byte , Ccw_cnt As Byte , Sw_cnt As Byte , Sw_t As Word
Dim Cw_cnt_old As Byte , Ccw_cnt_old As Byte , Sw_cnt_old As Byte
Dim First_loop_flag As Byte

Config Clockdiv = 1
Config Debounce = 2

$include "Arduino_pins.sub"                                 'include Arduino pin definitions

Config Arduino_pin#2 = Input
'Arduino_port#2 = 1
Config Arduino_pin#3 = Input
'Arduino_port#3 = 1
Config Arduino_pin#4 = Input
'Arduino_port#4 = 1
Config Arduino_pin#5 = Input
Arduino_port#5 = 1

Wait 1
Print "37_in_1 demo program 15a"
Print "2,3 = digital input (CLK)"
Print "4 = digita input (DT)"
Print "5 = digital input (SW)"
Print

First_loop_flag = 1

Do
  Debounce , Arduino_pin#2 , 0 , Clk_dn , Sub
  Debounce , Arduino_pin#3 , 1 , Clk_up , Sub
  Debounce , Arduino_pin#5 , 0 , Sw , Sub
  If cw_cnt <> cw_cnt_old Then
    Print "CW_cnt = " ; Cw_cnt
    cw_cnt_old = cw_cnt
  End If
  If ccw_cnt <> ccw_cnt_old Then
    Print "CCW_cnt = " ; Ccw_cnt
    ccw_cnt_old = ccw_cnt
  End If
  If sw_cnt <> sw_cnt_old Then
    Print "SW_cnt = " ; Sw_cnt ; " SW_t = " ; Sw_t ; " ms"
    sw_cnt_old = sw_cnt
  End If
  First_loop_flag = 0
Loop

End

Clk_dn:
  If First_loop_flag <> 1 Then
    If Arduino_pin#4 = 0 Then
      Incr Ccw_cnt
    Else
      Incr Cw_cnt
    End If
  End If
Return

Clk_up:
  If First_loop_flag <> 1 Then
    If Arduino_pin#4 = 0 Then
      Incr Cw_cnt
    Else
      Incr Ccw_cnt
    End If
  End If
Return

Sw:
  Incr sw_cnt
  sw_t = 2
  While Arduino_pin#5 = 0
    Incr sw_t
    If sw_t > 2000 Then
      Exit While
    End If
    Waitms 1
  Wend
Return
