'37_in_1, Rotary Encoder KY-040, INT0, INT1

$regfile = "m328pdef.dat"
$crystal = 16000000
$hwstack = 20
$swstack = 20
$framesize = 80

Dim Cw_cnt As Byte , Ccw_cnt As Byte , Sw_cnt As Byte , Sw_t As Word
Dim Cw_cnt_old As Byte , Ccw_cnt_old As Byte , Sw_cnt_old As Byte

Config Clockdiv = 1

$include "Arduino_pins.sub"                                 'include Arduino pin definitions

Config Arduino_pin#2 = Input
'Arduino_port#2 = 1
Config Arduino_pin#3 = Input
'Arduino_port#3 = 1
Config Arduino_pin#4 = Input
'Arduino_port#4 = 1
Config Arduino_pin#5 = Input
Arduino_port#5 = 1
Config Arduino_pin#13 = Output
Arduino_port#13 = 0

Config Int0 = Falling
On Int0 Int0_sub
Config Int1 = Rising
On Int1 Int1_sub
On Pcint2 Pcint2_sub
Set Pcmsk2.pcint21

Wait 1

Print "37_in_1 demo program 15b"
Print "2,3 = digital input (CLK)"
Print "4 = digita input (DT)"
Print "5 = digital input (SW)"
Print "13 = digital output (LED)"
Print

Set Eifr.intf0
Set Eifr.intf1
Set Pcifr.pcif2
Enable Int0
Enable Int1
Enable Pcint2
Enable Interrupts

Do
  Wait 1
  Arduino_port#13 = Not Arduino_port#13
  If Cw_cnt <> Cw_cnt_old Then
    Print "CW_cnt = " ; Cw_cnt
    Cw_cnt_old = Cw_cnt
  End If
  If Ccw_cnt <> Ccw_cnt_old Then
    Print "CCW_cnt = " ; Ccw_cnt
    Ccw_cnt_old = Ccw_cnt
  End If
  If Sw_cnt <> Sw_cnt_old Then
    Print "SW_cnt = " ; Sw_cnt ; " SW_t = " ; Sw_t ; " ms"
    Sw_cnt_old = Sw_cnt
  End If
Loop

End

Int0_sub:
  Waitms 2
  If Arduino_pin#2 = 0 Then
    Gosub Clk_dn
  End If
  Set Eifr.intf0
  Set Eifr.intf1
Return

Clk_dn:
  If Arduino_pin#4 = 0 Then
    Incr Ccw_cnt
  Else
    Incr Cw_cnt
  End If
Return

Int1_sub:
  Waitms 2
  If Arduino_pin#3 = 1 Then
    Gosub Clk_up
  End If
  Set Eifr.intf0
  Set Eifr.intf1
Return

Clk_up:
  If Arduino_pin#4 = 0 Then
    Incr Cw_cnt
  Else
    Incr Ccw_cnt
  End If
Return

Pcint2_sub:
  If Arduino_pin#5 = 0 Then
    Waitms 2
    If Arduino_pin#5 = 0 Then
      Gosub Sw
    End If
  End If
Return

Sw:
  Incr Sw_cnt
  Sw_t = 2
'  While Arduino_pin#5 = 0
'    Incr sw_t
'    If sw_t > 2000 Then
'      Exit While
'    End If
'    Waitms 1
'  Wend
Return